//---------------------------------------------+
//                          AutoFib TradeZones |
//          2010 Eagleye777, www.fxtools.info |
//           *Mod of AutoFibo by Julien Loutre |
//                           www.forexcomm.com |
//---------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Plum
#property indicator_color2  LightSkyBlue
#property indicator_style1  STYLE_DASHDOTDOT
#property indicator_style2  STYLE_DASHDOTDOT

//
//
//
//
//
 
extern int    Fib_Period      = 240;
extern string note            = "Price type 0=High/Low & 1=Open/Close";
extern int    price_type      = 0;  
extern bool   Show_StartLine  = false;
extern bool   Show_EndLine    = false;
extern bool   Show_Channel    = false;
extern int    Fib_Style       = 5;
extern color  Fib_Color       = DarkSlateGray;
extern color  StartLine_Color = RoyalBlue; 
extern color  EndLine_Color   = FireBrick; 
extern color  BuyZone_Color   = MidnightBlue;
extern color  SellZone_Color  = FireBrick;

extern string note2           = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";
 
//
//
//
//
//

double WWBuffer1[];
double WWBuffer2[];
double trend[];
double level_array[10]     = {  0,0.236,0.382,0.5,0.618,0.764,1,1.618,2.618,4.236 };
string leveldesc_array[10] = { "0","23.6%","38.2%","50%","61.8%","76.4%","100%","161.8%","261.80%","423.6%" };
string level_name;
string StartLine = "Start Line";
string EndLine   = "End Line";

//
//
//
//
//

int init() 
{    
     IndicatorBuffers(3);
     SetIndexBuffer(0, WWBuffer1);
     SetIndexBuffer(1, WWBuffer2);
     SetIndexBuffer(2, trend);
     
     if (Show_Channel)
     {
        SetIndexBuffer(0, WWBuffer1); SetIndexStyle(0,DRAW_LINE); SetIndexLabel(0,"High");
        SetIndexBuffer(1, WWBuffer2); SetIndexStyle(1,DRAW_LINE); SetIndexLabel(1,"Low");
     }
     
     else
     {
        SetIndexStyle(0,DRAW_NONE);
        SetIndexStyle(1,DRAW_NONE);
     }

     IndicatorDigits(Digits+2);
   
     IndicatorShortName("AutoFib TradeZones");
   
     ObjectCreate("FibLevels", OBJ_FIBO,      0,Time[0],High[0],Time[0],Low[0]);
     ObjectCreate("BuyZone",   OBJ_RECTANGLE, 0,0,0,0);
     ObjectCreate("SellZone",  OBJ_RECTANGLE, 0,0,0,0);
   
     if (Show_StartLine)  
     {
       if (ObjectFind(StartLine)==-1)
       {
          ObjectCreate(StartLine,OBJ_VLINE,0,Time[Fib_Period],Close[0]);
          ObjectSet(StartLine,OBJPROP_COLOR,StartLine_Color);
        }
      } 
      
      if (Show_EndLine)
      {
        if (ObjectFind(EndLine)==-1)
        {
           ObjectCreate(EndLine,OBJ_VLINE,0,Time[0],Close[0]);
           ObjectSet(EndLine,OBJPROP_COLOR,EndLine_Color);
        }
      } 
return(0);
}

//
//
//
//
//

int deinit() 
{
   ObjectDelete("FibLevels");
   ObjectDelete("BuyZone");
   ObjectDelete("SellZone");
   ObjectDelete("Start Line");
   ObjectDelete("End Line");
   
return(0);
}

//
//
//
//
//

int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit,BarShift,BarShift2;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {

       if (Show_StartLine)
       {   
         datetime HLineTime = ObjectGet(StartLine,OBJPROP_TIME1);

       if (HLineTime >= Time[i]) 
       {
         BarShift = 0;
       }
         BarShift = iBarShift(NULL,0,HLineTime);
   }   
   else  if (!Show_StartLine)           { BarShift = 0; }
         if (ObjectFind(StartLine)==-1) { BarShift = 0; }
   
   //
   //
   //
   //
   //
   
         if (Show_EndLine)
         {   
            datetime HLine2Time = ObjectGet(EndLine,OBJPROP_TIME1);

         if (HLine2Time>=Time[i]) 
         {
            BarShift2 = 0;
         }
            BarShift2 = iBarShift(NULL,0,HLine2Time);
   }   
   else  if (!Show_EndLine)           { BarShift2 = 0; }
         if (ObjectFind(EndLine)==-1) { BarShift2 = 0; }   
         
   //----------------------------------------------------------
   //
   //
   //
   //
 
   if (Show_StartLine)
   {
      double SellZoneHigh = iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,BarShift-BarShift2,BarShift2+1));
      double BuyZoneLow   = iLow(NULL, 0,iLowest(NULL, 0,MODE_LOW, BarShift-BarShift2,BarShift2+1));
   }
   
   if (!Show_StartLine)
   {
      SellZoneHigh = iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,Fib_Period,i+1));
      BuyZoneLow   = iLow(NULL, 0,iLowest(NULL, 0,MODE_LOW, Fib_Period,i+1));
    } 
   
      double   PriceRange      = SellZoneHigh - BuyZoneLow; 
      double   BuyZoneHigh     = BuyZoneLow   + (0.236 * PriceRange);
      double   SellZoneLow     = SellZoneHigh - (0.236 * PriceRange);
      datetime StartZoneTime   = Time[Fib_Period];
      datetime EndZoneTime     = Time[i]+Time[i];
      int      level_count     = ArraySize(level_array);
   
        WWBuffer1[i] = getPeriodHigh(Fib_Period,i);
        WWBuffer2[i] = getPeriodLow( Fib_Period,i);
        trend[i]     = trend[i+1];
        if (Close[i] >= BuyZoneHigh) trend[i] = 1; 
        if (Close[i] <= SellZoneLow) trend[i] =-1; 
        
        //
        //
        //
        //
        //
        
        if (Show_StartLine)
        {
        ObjectSet("FibLevels", OBJPROP_TIME1, Time[BarShift]);
        ObjectSet("FibLevels", OBJPROP_TIME2, Time[BarShift2]);
        }
      
        if (!Show_StartLine)
        {
          ObjectSet("FibLevels", OBJPROP_TIME1, StartZoneTime);
        }
          ObjectSet("FibLevels", OBJPROP_TIME2, Time[i]);
      
        if (Open[Fib_Period] < Open[i]) // Up
        { 
        
        if (Show_StartLine)
        {
          ObjectSet("FibLevels", OBJPROP_PRICE1, SellZoneHigh);
          ObjectSet("FibLevels", OBJPROP_PRICE2, BuyZoneLow);
        }
        if (!Show_StartLine)
        {
          ObjectSet("FibLevels", OBJPROP_PRICE1, getPeriodHigh(Fib_Period,i));
          ObjectSet("FibLevels", OBJPROP_PRICE2, getPeriodLow( Fib_Period,i));
        } 
      } 
      else 
      {
        if (Show_StartLine)
        {
          ObjectSet("FibLevels", OBJPROP_PRICE1, BuyZoneLow  );
          ObjectSet("FibLevels", OBJPROP_PRICE2, SellZoneHigh);
        }
        if (!Show_StartLine)
        {
           ObjectSet("FibLevels", OBJPROP_PRICE1, getPeriodLow( Fib_Period,i));
           ObjectSet("FibLevels", OBJPROP_PRICE2, getPeriodHigh(Fib_Period,i));
        }
        }
           ObjectSet("FibLevels", OBJPROP_LEVELCOLOR, Fib_Color  );
           ObjectSet("FibLevels", OBJPROP_STYLE,      Fib_Style  );
           ObjectSet("FibLevels", OBJPROP_FIBOLEVELS, level_count);
      
        for (int j=0; j<level_count; j++)
        {
           ObjectSet("FibLevels", OBJPROP_FIRSTLEVEL+j, level_array[j]);
           ObjectSetFiboDescription("FibLevels",j,  leveldesc_array[j]);
        }
   
        if (Show_StartLine)
        {
           ObjectSet("BuyZone", OBJPROP_TIME2, Time[BarShift] 
           );
           ObjectSet("BuyZone", OBJPROP_TIME1, Time[BarShift2]);
        }
      
        if (!Show_StartLine)
        {
           ObjectSet("BuyZone", OBJPROP_TIME2, StartZoneTime);
        }
           ObjectSet("BuyZone", OBJPROP_TIME1, EndZoneTime);
           ObjectSet("BuyZone", OBJPROP_PRICE1,BuyZoneLow);
           ObjectSet("BuyZone", OBJPROP_PRICE2,BuyZoneHigh);
           ObjectSet("BuyZone", OBJPROP_COLOR, BuyZone_Color);
      
        if (Show_StartLine)
        {
           ObjectSet("SellZone", OBJPROP_TIME2, Time[BarShift]);
           ObjectSet("SellZone", OBJPROP_TIME1, Time[BarShift2]);
        }
      
        if (!Show_StartLine)
        {
           ObjectSet("SellZone", OBJPROP_TIME2, StartZoneTime);
        }
           ObjectSet("SellZone", OBJPROP_TIME1, EndZoneTime);
           ObjectSet("SellZone", OBJPROP_PRICE1,SellZoneLow);
           ObjectSet("SellZone", OBJPROP_PRICE2,SellZoneHigh);
           ObjectSet("SellZone", OBJPROP_COLOR, SellZone_Color);  
        }
        
        //
        //
        //
        //
        //
               
        if (alertsOn)
        {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;

        //
        //
        //
        //
        //
         
        if (trend[whichBar] != trend[whichBar+1])
        if (trend[whichBar] == 1)
              doAlert("uptrend");
        else  doAlert("downtrend");       
   }
   return(0);           
}
 
//
//
//
//
//

double getPeriodHigh(int period, int pos)
{
       int i;
       double buffer = 0;
       
       for(i=pos;i<=pos+period;i++) 
       {
         if(price_type == 0) 
         {
         if(High[i] >  buffer) { buffer = High[i]; }
         }
         else 
         {
         if(Open[i] > Close[i]) 
         { // Down
         if(Open[i] >  buffer) { buffer = Open[i]; }
         } 
         else 
         {
         if(Close[i] > buffer) { buffer = Close[i]; }
       }
    }
}
return (buffer);
}

//
//
//
//
//

double getPeriodLow(int period, int pos) 
{
       int i;
       double buffer = 100000;
        
       for (i=pos;i<=pos+period;i++) 
       {
         if (price_type == 0) 
         {
         if (Low[i] <   buffer) { buffer = Low[i]; }
         } 
         else 
         {
         if (Open[i] > Close[i]) 
         { // Down
         if (Close[i] < buffer) { buffer = Close[i]; }
         } 
         else 
         {
         if (Open[i] <  buffer) { buffer = Open[i]; }
       }
   }
}
return (buffer);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," AutoFib Tradezone ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," AutoFib TradeZone "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}